var rdi_loadStatus = false;
var rdi_initStatus = false;

var rdi_currRD = null;
var rdi_isRD = false;

var rdi_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.subjects_prefix_switch.");

var rdi_main = {

     subjects_prefix_switch : function() {
        var subjectElement = GetMsgSubjectElement();
        
         subjectElement.editor.beginTransaction();
         
        if (!rdi_isRD && rdi_currRD != null) {
            rdi_main.insertRD(subjectElement, rdi_currRD);
        } else {
            if (rdi_main.searchRD(subjectElement))
                rdi_main.removeRD(subjectElement);
        }

        SetComposeWindowTitle();
        subjectElement.editor.endTransaction();
    },

    searchRD : function(subjectElement) {
        var indexOf = subjectElement.value.indexOf(rdi_currRD);
        return (indexOf > -1);
    },

    removeRD : function(subjectElement) {
        var start = subjectElement.value.indexOf(rdi_currRD);
        var len = rdi_currRD.length
        
        subjectElement.value = 
            // 0 - RD
            subjectElement.value.substring(0, start) 
            // RD - koniec z usuniecie spacji po RD
            + (subjectElement.value.substring(start+len).charAt(0) == ' '
                ? subjectElement.value.substring(start + len + 1)
                : subjectElement.value.substring(start + len));
        
        rdi_isRD = false;
    },

    insertRD : function(subjectElement, rd) {
        subjectElement.editor.beginningOfDocument();
        subjectElement.value = rd + ' ' + subjectElement.value;
        
        rdi_currRD = rd;
        rdi_isRD = true;
    },

    loadRD : function(idx, del) {
        var rd = rdi_main.loadRDProperty(1)[idx];
       
        var subjectElement = GetMsgSubjectElement();
        var currentEditor = subjectElement.editor;
        var initialRange = currentEditor.selection.getRangeAt(0).cloneRange();
        var hasRD = rdi_main.searchRD(subjectElement);
        currentEditor.beginTransaction();

        if (hasRD && del) {
            rdi_main.removeRD(subjectElement);
        }
        
        rdi_main.insertRD(subjectElement, rd);
        
        SetComposeWindowTitle();
        currentEditor.endTransaction();

        currentEditor.selection.removeAllRanges();
        currentEditor.selection.addRange(initialRange);

        rdi_main.sanitize();
    },

    sanitize : function()  {
        rdi_initStatus = false;
    },

    onLoad : function() {
        if (rdi_loadStatus)
            return;

        rdi_main.ensurePrefs();
        rdi_main.init();

        rdi_loadStatus = true;
    },

    ensurePrefs : function() {
        var prefs = [       "offbydefault",
                            "contextmenu"             ];

        for (var i = 0; i < prefs.length; i++) {
            if (rdi_prefs.getPrefType(prefs[i]) == rdi_prefs.PREF_INVALID)
            {
                rdi_main.openOptions(true);
                return;
             }
        }
    },

    init : function() {
        if (rdi_initStatus)
            return;

        var defaultRD;
        var offbydefault;
        var contextmenu;
        var initdelay;

        try {
            defaultRD = parseInt(rdi_prefs.getCharPref("defaultrd"));
            offbydefault = rdi_prefs.getBoolPref("offbydefault");
            contextmenu = rdi_prefs.getBoolPref("contextmenu");
        } catch (e) {
            defaultRD = -1;
            offbydefault = false;
            contextmenu = true;
            initdelay = 1000;
        }

        var ctxmenu = document.getElementById("subjects_prefix_switchContext");

        ctxmenu.setAttribute("hidden", !contextmenu);

        if ((defaultRD > -1) || offbydefault) {
            setTimeout("rdi_main.delayedInit(" + defaultRD + ", " + offbydefault + ")", initdelay);
        }
        
        rdi_initStatus = true;
    },

    delayedInit : function(defaultRD, offbydefault)
    {
        var hasDefaultRD = defaultRD > -1;
        if (hasDefaultRD) {
            rdi_currRD = rdi_main.loadRDProperty(1)[defaultRD];
        }
        
        if (!offbydefault && hasDefaultRD) {
            rdi_main.loadRD(defaultRD, rdi_initStatus);
        }
    },

    initMenuPopup : function(element)
    {
        var menuPopup = document.getElementById("subjects_prefix_switchMenuPopup-" + element);

        rdi_main.removeMenuItems(menuPopup);

        if (element != "toolbar")
        {
            rdi_main.insertOnOffItem(menuPopup, rdi_main.getLocalizedMessage("menuItem.onOff"), rdi_main.getLocalizedMessage("toolTip.onOff"));
            menuPopup.appendChild(document.createElement("menuseparator"));
        }

        var descriptionData = rdi_main.loadRDProperty(0);
        var rdData = rdi_main.loadRDProperty(1);

        var description;
        var rd;
        
        for (var i = 0; i < descriptionData.length; i++) {
            description = descriptionData[i];
            rd = rdData[i];
            rdi_main.insertMenuItem(menuPopup, description, rd, i);
        }

        if (descriptionData.length > 0) {
            menuPopup.appendChild(document.createElement("menuseparator"));
        }
        
        rdi_main.insertOptionsItem(menuPopup, rdi_main.getLocalizedMessage("menuItem.options"), rdi_main.getLocalizedMessage("toolTip.enterOptions"));
    },

    loadRDProperty : function(idx)
    {
        var dataString;
        var items = new Array();

        try {
            dataString = rdi_prefs.getComplexValue("rds", Components.interfaces.nsISupportsString).data;

            if (dataString != "") {
                var itemStrings = dataString.split("|");

                var itemData;

                for (var i = 0; i < itemStrings.length; i ++) {
                    itemData = itemStrings[i].split("*");
                    items.push((itemData[idx]) ? itemData[idx] : "");
                }
            }
        }
        catch (e) {}

        return items;
    },

    loadFile : function(file)
    {
        return file;
    },

    removeMenuItems : function(menu)
    {
        var children = menu.childNodes;

        for (var i = children.length - 1; i >= 0; i--) {
            menu.removeChild(children[i]);
        }
    },

    insertMenuItem : function(menu, label, tooltip, idx)
    {
        var item = document.createElement("menuitem");

        item.setAttribute("id", "subjects_prefix_switch_RD_" + idx);
        item.setAttribute("label", label);
        item.setAttribute("tooltiptext", tooltip);
        item.setAttribute("oncommand", "rdi_main.loadRD(" + idx + ", true); event.stopPropagation();");
        item.setAttribute("disabled", false);

        menu.appendChild(item);
    },

    insertOptionsItem : function(menu, label, tooltip)
    {
        var item = document.createElement("menuitem");

        item.setAttribute("id", "subjects_prefix_switch_openOptions");
        item.setAttribute("label", label);
        item.setAttribute("tooltiptext", tooltip);
        item.setAttribute("oncommand", "rdi_main.openOptions(false); event.stopPropagation();");
        item.setAttribute("disabled", false);

        menu.appendChild(item);
    },

    insertOnOffItem : function(menu, label, tooltip) {
        var item = document.createElement("menuitem");

        item.setAttribute("id", "subjects_prefix_switch_onOff");
        item.setAttribute("label", label);
        item.setAttribute("tooltiptext", tooltip);
        item.setAttribute("oncommand", "rdi_main.subjects_prefix_switch(); event.stopPropagation();");
        item.setAttribute("disabled", false);

        menu.appendChild(item);
    },

   getLocalizedMessage : function(msg)
    {
        return document.getElementById("subjects_prefix_switch.locale").getString(msg);
    },

    openOptions : function(autosave)
    {
        return window.openDialog("chrome://subjects_prefix_switch/content/options.xul", "_blank", "chrome, modal, resizable=yes", autosave);
    },

    dump : function(str) {
        var csClass = Components.classes['@mozilla.org/consoleservice;1'];
        var cs = csClass.getService(Components.interfaces.nsIConsoleService);

        cs.logStringMessage((new Date()).getTime() + ": " + str);
    }
};

window.addEventListener("load", rdi_main.onLoad, true);
window.addEventListener("compose-window-close", rdi_main.sanitize, true);
window.addEventListener("compose-window-reopen", rdi_main.init, true);
